%
%       ADA_ARR.M
%
clear all;
%       Load array data
arr_dat;
%       Load scenario data
sce_dat;
%       Covariance, snapshots, Wiener and MSE beamformers
sna_pro;
%       Select reference mode (1 actual, 0 regenerated)
auso=menu('Select reference','actual','regenerated');
if auso==1;
  iref=1;disp('Actual reference');
elseif auso==2;
  iref=0;disp('Reference regenerated at the array output');
end;
%       Number of processed snapshots between successive plots
%       in the adaptive beamforming algorithm
iplot=200;
%       Algorithm selection
ial=menu('Select an algorithm','nlms','sqrls');
if ial==1;
  figure(5);clf;
  al_nlms;
elseif ial==2;
  figure(5);clf;
  al_sqrls;
end;
%       Plot detector features
if iref==0;
  hold off;
  nplot=length(fr);
  xaux=1:1:nplot;
  yaux=fr;figure(11);clf;
  ybase=fsou(itipo)*ones(1,nplot);
  xdib=[min(xaux) max(xaux) 0 0.5];
  axis(xdib);
  plot(xaux,yaux);
  xlabel('snapshots');
  ylabel('local frequency');
  title('Detector parameters');
  grid;
  hold on;
  plot(xaux,ybase,'b');
  pause(0.2);
%  print;
  hold off;
%  yaux=fase(1:nsnap);
%  xdib=[min(xaux) max(xaux) min(yaux) max(yaux)];
%  axis(xdib);
%  plot(xaux,yaux);
%  xlabel('snapshots');
%  ylabel('local phase');
%  title('Detector parameters');
%  grid;
%  pause;
end;
%       Plot the learning curve
%print;
nplot=length(error);
xaux=1:1:nplot;
ybase=abs(error).*abs(error);
a=[1 -0.95];
b=[0.05];
yaux=filtro(ybase,a,b,1,'Error smoothing filter',6);
clear a b;figure(7);clf;
xdib=[min(xaux) max(xaux) min(yaux) max(yaux)];
axis(xdib);
ybase=real(err_op*ones(1,nplot));
plot(xaux,10*log10(ybase),'r');
xlabel('snapshots');
ylabel('rms error dB.');
title('Learning curve');
grid;
hold on;
plot(xaux,10*log10(yaux),'b');
pause(2);
%print;
hold off;
%       Plot the last array factor
%
stri=['Last array factor'];
if iexp==2;
  uaso=sca_2d(fve,fva,d,azir,Anlms,stri,8);
else;
  uaso=sca_1d(fve,d,azir,Anlms,soue,souldb,stri,tmax,8);
end;
%print;
%
%       Plot SNR evolution
figure(10);clf;
nplot=length(snr);
ybase=snr_op*ones(1,nplot);
xdib=[min(xaux) max(xaux) min(snr)-1 max(snr)+1];
axis(xdib);
plot(xaux,ybase,'b');
xlabel('snapshots');
ylabel('snr dB.');
title('SNR evolution');
grid;
hold on;
plot(xaux,snr,'r');
pause(2);
%print;
hold off;
disp('End of the program');
