%
%       AL_NLMS.M
%
Anlms=zeros(nsen,1);
Anlms(1)=1;
s=['----------------------------------'];disp(s),
s=['NLMS algorithm'];disp(s);
power=X(:,1)'*X(:,1);
ref=zeros(nsnap,1);
ind=0;
beta=0.998;
%       Receiver for unmodulated carrier
pa=[0 0]';
covpa=1e4*eye(2);
residuo=[0.001 0; 0 0.00001];
%       Receiver for BPSK
ilin=1;
b=ones(1,nmos(itipo));
fase(1)=0;
% Samples to keep non active the algorithm.
iact=0;
%       Algorithm parameters
alfa=0.1;
s=['Missadjustment equal to ' num2str(alfa*100) '%'];disp(s);
%       Main loop
for i=1:nsnap;
  amp=nsen*sqrt(power/nsen);
  ysal(i)=Anlms'*X(:,i);
%       Actual reference
  if iref==1;
    ref(i)=(nsen+1)*sou(itipo,i);
    error(i)=ref(i)-ysal(i);
    iact=1;
    inact=1;
  else;
%       Receiver umodulated reference
    if stip(itipo)==0;
      yout=ysal(i);
      [pa covpa]=ekf_arr(yout,pa,covpa,residuo);
      ref(i+1)=amp*exp(sqrt(-1)*pa(1));
      fr(i)=pa(2);
      pa(1)=unwrap(pa(1));
      error(i)=ref(i)-ysal(i);
      iact=1;
      inact=1;
%       Receiver BPSK reference
    elseif stip(itipo)==2;
%               Carrier recovery
      ysa=ysal(i);
      auso=ysa*ysa;
      yaux(i)=ysa*exp(-sqrt(-1)*fase(i));
      [pa covpa]=ekf_arr(auso,pa,covpa,residuo);
      fase(i+1)=pa(1)/2;
      fr(i)=pa(2)/2;
%               Matched filtering
      ybase(i)=0;
      lmax=min(ilin,nmos(itipo));
      for j=1:lmax;
        ybase(i)=ybase(i)+yaux(i-j+1)*b(j);
      end;
%               Timing acquisition
      if i>1;
        if abs(real(ybase(i)))<abs(real(ybase(i-1)));
          if i>nmos(itipo);
            idet=1;
          end;
        else;
          if ilin==nmos(itipo)+1;
            idet=1;
          end;
          ilin=ilin+1;
        end;
      end;
%               Bit detector
      if idet==1;
        xlalo=[i ilin datref(i-1)];
        ybase(i)=0;
        ilin=2;
        idet=0;
        if real(ybase(i-1))>0;
          dato=0;
        else;
          dato=3.14159265;
        end;
        xlalo=[xlalo dato];
        disp(xlalo);
%    
        for j=1:nmos(itipo);
          ref(i-j)=amp*exp(sqrt(-1)*(fase(i-j)+dato));
        end;
        iact=nmos(itipo)+1;
        inact=2;
      end;
%      
    end;
  end;
  power=beta*power+(1-beta)*X(:,i)'*X(:,i);
  if iact>0;
    for j=iact:-1:inact;
      ysal(i-j+1)=Anlms'*X(:,i-j+1);
      error(i-j+1)=ref(i-j+1)-ysal(i-j+1);
%
%       Adaptive algorithm
%
        Anlms=Anlms+(alfa/power)*conj(error(i-j+1))*X(:,i);
%
%       Calculo de la snr
%
      buso=Anlms'*Anlms;
      for iaus=1:nsou;
       if iaus==itipo;
         auso=(soul(itipo)^2)*(abs(Anlms'*S(:,itipo)))^2;
       else;
         buso=buso+(soul(iaus)^2)*(abs(Anlms'*S(:,iaus)))^2;
       end;
      end;
      snr(i-j+1)=10*log10(auso/buso);
    end;  
%
%       Dibujo del diagrama cada iplot
  end;
  iact=20;
  iaus=rem(i-20,iplot);
  stri=['Beamformer evolution'];
  if iaus==0;
    aus=sca_alg(fve,d,azir,Anlms,soue,souldb,ind,stri,tmax);
    point(i)=tmax*pi/180;
    hold on;pause(1);
    ind=1;
  end;
end;
%print;
clear power beta alfa yout ref buso auso aus stri;
clear pa covpa residuo ysal ybase yaux refer ilin;
clear idet iact inact xlalo alfa;
pack;
