%
%  	File PATTERN2.M
%
%	From the 2d plot zpat, plots the graphic of the involving beamvector
% response. The actual position of the sources and their
% levels are provided in souele, souazi and soulev arrays. Vector teta contains
% the scanning array in degrees, and souzai the same for the azimuth dimension;
% string stri is the desired title for the graphic. The parameters aa and bb 
% specify the figure number and the seconds the figure is hold under the pause
% command. Finally, the parameter cc equal one indicates that the contour diagram
% is desired.
%
%  Miguel A. Lagunas			Marzo 1996
%
%................................................................
function [pr]=pattern2(zp,stri,sx,sy,xx,yy,ndib,souele,souazi,soulev,aa,bb,cc);
figure(aa);clf;nsou=length(souele);aro=sin(souele*pi/180);bro=souazi*pi/180;
arx=aro.*cos(bro);ary=aro.*sin(bro);
%
for l=1:length(yy);
  sxa=sx.*(sy(:,l)*ones(1,length(xx)));zpat(:,l)=10*log10(abs(sxa'*zp));
end;
% Define the floor for the plot as -0 dB. below the maximum source level
zfloor=min(min(zpat))-0;
for i=1:length(xx);
  for j=1:length(yy);
    if xx(i)^2+yy(j)^2>1;
      zpat(i,j)=zfloor;
    end;
    if zpat(i,j)<zfloor;
        zpat(i,j)=zfloor;
    end;
  end;
end;
mesh(xx,yy,zpat);hold on;grid;
ylabel('Slowness/azimuth');zlabel('dBs');
xlabel('This axis west-->east');title(stri);
% Plot the actual source location
au=min(min(zpat));bu=max(max(zpat));zref=zfloor*ones(size(zpat));
for i=1:length(xx);
  for l=1:nsou;
    if xx(i)<=arx(l);
      if xx(i+1)>arx(l);
        for j=1:length(yy);
          if yy(j)<=ary(l);
            if yy(j+1)>ary(l);
              %zref(i,j)=soulev(l);
              zref(i,j)=bu;
            end;
          end;
        end;
      end;
    end;
  end;
end;
mesh(xx,yy,zref);view(45,60);hold off;
pause(bb);pr=1;
% countour plot when desired
if cc==1;
  figure(aa+1);
  clf;contour(xx,yy,zpat,20);hold on;grid;contour(xx,yy,zref,10);
  xlabel('South');ylabel('Slowness/azimuth');title(stri);
  pause(bb);
end;
%_______________________________________________________________________