%
%       Fichero SCE_DAT.M
%
% Load arr_dat.m before to execute this file
twopi=2*pi;
stri=['ATTENTION There is an error in source settings in file sce_dat.m'];
% number of sources
nsou=3;
s=['Number of sources........' num2str(nsou)];disp(s);
% sources' elevation
if icip==2;
%PLANAR
   soue=[10 35 65]';soua=[0 130 -80]';
elseif icip==1;
   %Linear
   soue=[10 25 -65]';soua=[0 0 0]';
end;
if length(soue)==nsou;
  s=['Sources elevation in degrees ' num2str(soue') ];disp(s); 
else;
  disp(stri);
  quit;
end;
souer=soue*pi/180;
if length(soua)==nsou;
  s=['Sources azimuth in degrees  ' num2str(soua')];disp(s); 
else;
  disp(stri);
  quit;
end;
souar=soua*pi/180;
% Form DOAs matrix
auso=sin(souer).*cos(souar);
buso=sin(souer).*sin(souar);
cuso=(d.*cos(azir))*auso';
duso=(d.*sin(azir))*buso';
S=exp(ii*twopi*(cuso+duso));
clear auso buso cuso duso;
%
% Possible modulation cases for every source
%       0 unmodulated carrier
%       1 DSB modulation
%       2 M-PSK modulation (requires number of levels and samples per symbol)
%                         
%
s1=['Unmodulated'];
s2=['DSB'];
s3=['PSK'];
%
stip=[2 0 2];
if length(stip)==nsou;
  auso=0;
else;
  disp(stri);
  quit;
end;
for i=1:nsou;
 s=['Modulation of source ' num2str(i)];disp(s);
 if stip(i)==0;
   disp(s1);
 elseif stip(i)==1;
   disp(s2);
 elseif stip(i)==2;
   disp(s3);
 end;
end;
clear s1 s2 s3 s;
nlev=[2 0 4];
nmos=[4 0 4];
if length(nlev)==nsou;
  auso=0;
else;
  disp(stri);
  quit;
end;
if length(nmos)==nsou
  auso=0;
else;
  disp(stri);
  quit;
end;
% source to be the reference in the beamforming
itipo=2;
s=['The reference source will be source number...' num2str(itipo)];disp(s);
% central frequency of the sources
fsou=[0.2 0.1 0.25];
if length(fsou)==nsou;
  s=['Central frequency of every source...' num2str(fsou)];disp(s);
else;
  disp(stri);
  quit;
end;
% source levels
souldb=[24 20 25];
if length(souldb)==nsou;
  s=['Source levels in dB...........' num2str(souldb)];disp(s);
else;
  disp(stri);
  quit;
end;
for i=1:nsou;
  soul(i)=sqrt(10^(souldb(i)/10));
end;
pause(5);
%
% Vectors for source waveforms
%
xplot=1:1:100;
for i=1:nsou;
  fase=rand*twopi/360;
  if i==itipo;
    fase=1;
  end;
  fas=0:1:nsnap-1;
  fas=twopi*fsou(i)*fas+fase;
  if stip(i)==0;
    sou(i,:)=soul(i)*exp(ii*fas);
    auso=real(sou(i,1:max(xplot)));
    xdib=[min(xplot) max(xplot) min(auso) max(auso)];
    axis(xdib);
    plot(xplot,auso);
    title('Source waveforms ..Unmodulated source ');
    xlabel('samples');
    ylabel('volts');
    pause(1);
    clear auso;
  end;figure(1);clf;
  if stip(i)==1;
    a=[1 -1.8 0.81];
    b=[1];
    xin=rand(1,nsnap);
    ymod=filtro(xin,a,b,1);
    ymod=ymod*sqrt(nsnap)/norm(ymod);
    sou(i,:)=soul(i)*exp(ii*fas).*ymod;
    auso=real(sou(i,1:max(xplot)));
    xdib=[min(xplot) max(xplot) min(auso) max(auso)];
    axis(xdib);
    plot(xplot,auso);
    title('Source waveforms ..DSB modulation');
    xlabel('samples');
    ylabel('volts');
    pause(1);
    clear xin a b auso ymod;
  end;
  if stip(i)==2;
    n4=nsnap/nmos(i);
    dat=round(rand(1,n4)*(nlev(i)-1))*(twopi/nlev(i));
    dato=[];
    for j=1:n4;
      for ij=1:nmos(i);
        dato=[dato dat(j)];
      end;
    end;
    sou(i,:)=soul(i)*exp(ii*(fas+dato));
    auso=real(sou(i,1:max(xplot)));
    xdib=[min(xplot) max(xplot) min(auso) max(auso)];
    axis(xdib);
    plot(xplot,auso);
    title('Source waveforms ..m-PSK modulation')
    xlabel('samples');
    ylabel('volts');
    pause(1);
    if i==itipo;
      datref=dato;
    end;
    clear n4 dat auso dato;
  end;
end;
clear auso xplot xdib fas fase;
pack;
%
%
%
